/* CrashAbort.h -- Addition to get crashdumps from Firebird.
 *
 * The contents of this file are subject to the Interbase Public License
 * Version 1.0 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * http://www.firebirdsql.org/index.php?op=doc&id=ipl
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * 
 * The Original Code was created by Kerio Technologies.
 * 
 * Copyright 2008 Kerio Technologies Inc. All rights reserved.
 * 
 */

#pragma once
#include <windows.h>
#include <process.h>
#include <stdlib.h>

#ifndef	WIN_NT
#error Kerio changes apply only to Win32 build
#endif

class Vc7Crasher {
private:
	static void __cdecl execute(void *unused)
	{
		*reinterpret_cast<int*>(NULL) = 0;
	}

public:
	// We have to create a new thread and crash in there.
	static void crashMe()
	{
		_beginthread(execute, 0, NULL);
		::Sleep(INFINITE);
	}
};

#define abort()		Vc7Crasher::crashMe()
